(function(window, mui, template) {
	var plusMap;
	var userMarker;
	var userPosition;
	var queryType = {
		YUGONGYING: '0',
		ZHAOPAIGUA: '1',
		PEITAO: '5',
		XIANGMU: '6'
	};
	var peitaoSubtype = {
		hospResult: 504,
		schoolResult: 503,
		com: 502,
		bankResult: 505,
		trackStation: 501
	};

	var navTemplate = {
		icons: '<table class="nav-table">\
				<tr>\
					<td colspan="4" class="nav-icons-cell">附近</td>\
				</tr>\
				<tr>\
					<td class="nav-icons-cell">\
						<a ontap="mapApi.query(\'YUGONGYING\')">\
							<img width="50px" height="50px" alt="预供应" src="../../icon/pop_func_icon1@2x.png"/>\
						</a>\
					</td>\
					<td class="nav-icons-cell">\
						<a ontap="mapApi.query(\'ZHAOPAIGUA\')">\
							<img width="50px" height="50px" alt="招拍挂" src="../../icon/pop_func_icon2@2x.png"/>\
						</a>\
					</td>\
					<td class="nav-icons-cell">\
						<a ontap="mapApi.query(\'PEITAO\')">\
							<img width="50px" height="50px" alt="配套" src="../../icon/pop_func_icon3@2x.png"/>\
						</a>\
					</td>\
					<td class="nav-icons-cell">\
						<a ontap="mapApi.query(\'XIANGMU\')">\
							<img width="50px" height="50px" alt="项目" src="../../icon/pop_func_icon4@2x.png"/>\
						</a>\
					</td>\
				</tr>\
				<tr>\
					<td class="nav-icons-cell">预供应</td>\
					<td class="nav-icons-cell">招拍挂</td>\
					<td class="nav-icons-cell">配套</td>\
					<td class="nav-icons-cell">项目</td>\
				</tr>\
			</table>',
		location: '<table class="nav-table">\
				<tr>\
					<td class="nav-location-cell">地图位置</td>\
				</tr>\
				<tr>\
					<td class="nav-location-cell" id="postionInfo">{{address}}</td>\
				</tr>\
				<tr>\
					<td style="text-align:right;padding-right:5px">\
						<a ontap="mapApi.change.toicon()">\
							<img height="48px" alt="搜周边" src="../../icon/btn_around@2x.png"/>\
						</a>\
					</td>\
				</tr>\
			</table>',
		landinfo: {}
	};

	navTemplate.landinfo[queryType.YUGONGYING] = '<div ontap="gotoDetail(\'YUGONGYING\', {{Id}})">\
	<p>{{LandAddress}}</p><p class="right">{{DistanceM}}米</p>\
	<table class="nav-table">\
		<tr>\
			<td class="nav-landinfo-cell">土地面积：{{UseAreaMu}}亩</td>\
			<td class="nav-landinfo-cell">容积率：{{Rjl}}</td>\
		</tr>\
		<tr>\
			<td class="nav-landinfo-cell">预计出让时间：{{PreResmiseDateStr}}</td>\
			<td class="nav-landinfo-cell">出让方式：{{PreResmiseType}}</td>\
		</tr>\
		<tr>\
			<td class="nav-landinfo-cell">用地性质：{{LandUseType}}</td>\
			<td class="nav-landinfo-cell right">\
				<a class="mui-icon icon-fav {{if FollowStatus}}faved{{/if}}" alt="收藏" ontap="toggleFav(this, {{Id}})"></a>\
			</td>\
		</tr>\
	</table></div>';
	navTemplate.landinfo[queryType.ZHAOPAIGUA] = '<div ontap="gotoDetail(\'ZHAOPAIGUA\', {{Id}})">\
	<p>{{LandAddress}}</p><p class="right">{{DistanceM}}米</p>\
	<table class="nav-table small">\
		<tr>\
			<td class="nav-landinfo-cell">土地面积：{{UseAreaMu}}亩</td>\
			<td class="nav-landinfo-cell">容积率：{{Rjl}}</td>\
		</tr>\
		<tr>\
			<td class="nav-landinfo-cell">出让时间：{{RemiseDate}}</td>\
			<td class="nav-landinfo-cell">用途分类：{{LandUseType}}</td>\
		</tr>\
		<tr>\
			<td class="nav-landinfo-cell">成交单价：{{DealPrice}}万/亩</td>\
			<td class="nav-landinfo-cell">楼面地价：{{LandFloorPrice}}元/平米</td>\
		</tr>\
	</table></div>';
	navTemplate.landinfo[queryType.PEITAO] = {};
	navTemplate.landinfo[queryType.PEITAO][peitaoSubtype.trackStation] = '<table class="nav-table">\
		<tr>\
			<td class="nav-landinfo-cell">{{TsName}}</td>\
			<td class="nav-landinfo-cell">{{DistanceM}}米</td>\
		</tr>\
		<tr>\
			<td class="nav-landinfo-cell" colspan=2>[{{LineName}}] [{{TypeName}}] [{{StateName}}]</td>\
		</tr>\
	</table>';
	navTemplate.landinfo[queryType.PEITAO][peitaoSubtype.com] = '<div ontap="gotoDetail(\'PEITAO\', {{Id}})">\
	<p>{{BaseName}}</p><p class="right">{{DistanceM}}米</p>\
	<table class="nav-table">\
		<tr>\
			<td class="nav-landinfo-cell">占地面积：{{UsingLandArea}}平米</td>\
			<td class="nav-landinfo-cell">开业时间：{{OpenDate}}</td>\
		</tr>\
		<tr>\
			<td class="nav-landinfo-cell">主力店：暂未收录</td>\
			<td class="nav-landinfo-cell">商业进度：{{ProcessName}}</td>\
		</tr>\
	</table></div>';
	navTemplate.landinfo[queryType.PEITAO][peitaoSubtype.schoolResult] =
		navTemplate.landinfo[queryType.PEITAO][peitaoSubtype.hospResult] =
		navTemplate.landinfo[queryType.PEITAO][peitaoSubtype.bankResult] = '<div><p>{{Name}}</p><p class="right">{{DistanceM}}米</p></div>\
		<table class="nav-table">\
			<tr>\
				<td class="nav-landinfo-cell" colspan=2>{{Address}}</td>\
			</tr>\
			<tr>\
				<td class="nav-landinfo-cell" colspan=2>{{Telphone}}</td>\
			</tr>\
		</table>';
	navTemplate.landinfo[queryType.XIANGMU] = '<div ontap="gotoDetail(\'XIANGMU\', {{Id}})">\
	<p>{{BaseName}}</p><p class="right">{{DistanceM}}米</p>\
	<table class="nav-table small">\
			<tr>\
			<td class="nav-landinfo-cell">住宅均价：{{MeanPrice}}元/平米</td>\
			<td class="nav-landinfo-cell">楼面地价：{{LandFloorPrice}}元/平米</td>\
		</tr>\
		<tr>\
			<td class="nav-landinfo-cell">占地面积：{{UsingArea}}平米</td>\
			<td class="nav-landinfo-cell">预售面积：{{UsedLandArea}}平米</td>\
		</tr>\
		<tr>\
			<td class="nav-landinfo-cell">土地存量：{{LandLeftArea}}平米</td>\
		</tr>\
	</table></div>';

	var changeBar = {
		toicon: function() {
			var html = navTemplate.icons;
			var container = document.getElementById('nav-container');
			container.children.length && container.removeChild(container.children[0]);
			container.innerHTML = html;
			return false;
		},
		tolocation: function(data) {
			var render = template.compile(navTemplate.location);
			var html = render(data);
			var container = document.getElementById('nav-container');
			container.children.length && container.removeChild(container.children[0]);
			container.innerHTML = html;
			return false;
		},
		tolandinfo: function(data) {
			var render = data._type == query.type.PEITAO ? template.compile(navTemplate.landinfo[data._type][data._POIType]) : template.compile(navTemplate.landinfo[data._type]);
			var html = render(data);
			var container = document.getElementById('nav-container');
			container.children.length && container.removeChild(container.children[0]);
			container.innerHTML = html;
			return false;
		}
	};

	var mapType = {
		type: {
			standard: "MAPTYPE_NORMAL",
			satellite: "MAPTYPE_SATELLITE"
		},
		change: function(type) {
			plusMap.setMapType(plus.maps.MapType[mapType.type[type]]);
		}
	};

	var listData = {};	//for 列表页面
	
	var GeometryHelper = {
		Markers: {
			Items: {},
			add: function(dataitem, marker) {
				var type = dataitem._type, POIType = dataitem._POIType;
				dataitem.isShow = true;
				if (!POIType) {
					GeometryHelper.Markers.Items[type] = GeometryHelper.Markers.Items[type] || [];
					GeometryHelper.Markers.Items[type].push(marker);
					listData[type] = listData[type] || [];
					listData[type].push(dataitem);
				} else {
					GeometryHelper.Markers.Items[type] = GeometryHelper.Markers.Items[type] || {};
					GeometryHelper.Markers.Items[type][POIType] = GeometryHelper.Markers.Items[type][POIType] || [];
					GeometryHelper.Markers.Items[type][POIType].push(marker);
					listData[type] = listData[type] || {};
					listData[type][POIType] = listData[type][POIType] || [];
					listData[type][POIType].push(dataitem);
				}
			},
			show: function(type, POIType) {
				var _markers = [], _listData = [];
				if (!POIType) {
					_markers = GeometryHelper.Markers.Items[type];
					_listData = listData[type];
				} else {
					_markers = GeometryHelper.Markers.Items[type][POIType];
					_listData = listData[type][POIType];
				}
				for (var i = 0; i < _markers.length; i++) {
					plusMap.addOverlay(_markers[i]);
					_listData[i].isShow = true;
				}
			},
			hide: function(type, POIType) {
				var _markers = [], _listData = [];
				if (!POIType) {
					_markers = GeometryHelper.Markers.Items[type];
					_listData = listData[type];
				} else {
					_markers = GeometryHelper.Markers.Items[type][POIType];
					_listData = listData[type][POIType];
				}
				if(!_markers) {
					return;
				}
				for (var i = 0; i < _markers.length; i++) {
					plusMap.removeOverlay(_markers[i]);
					_listData[i].isShow = false;
				}
			},
			clear: function(type, POIType) {
				GeometryHelper.Markers.hide(type, POIType);
				if (!POIType) {
					GeometryHelper.Markers.Items[type] && delete GeometryHelper.Markers.Items[type];
				} else {
					GeometryHelper.Markers.Items[type][POIType] && delete GeometryHelper.Markers.Items[type][POIType];
				}
				if(type == queryType.YUGONGYING) {
					for(var i=0; i<GeometryHelper.MultiPolygons.length; i++) {
						plusMap.removeOverlay(GeometryHelper.MultiPolygons[i]);
					}
				}
			},
			clearAll: function() {
				//GeometryHelper.Markers.Items = {};
				//plusMap.clearOverlays();
				for(var type in GeometryHelper.Markers.Items) {
					if(type != queryType.YUGONGYING) {
						for(var POIType in GeometryHelper.Markers.Items[type]) {
							GeometryHelper.Markers.clear(type, POIType);
						}
					} else {
						GeometryHelper.Markers.clear(type);
					}
				}
				listData = {};
				mui('.mui-icon-right-nav')[0].style.display = 'none';
				plus.webview.getWebviewById("view/land/land_map_menu.html").evalJS("clearPOIType()");
			}
		},
		Marker: {
			build: function(dataitem) {
				(function(dataitem) {
					plus.maps.Map.convertCoordinates(new plus.maps.Point(Number(dataitem.Lng), Number(dataitem.Lat))
					, {coordType: "gcj02"}, function(e) {
						var marker = new plus.maps.Marker(new plus.maps.Point(e.coord.longitude, e.coord.latitude));
						marker.setIcon(dataitem.Icon);
						marker.onclick = function() {
							changeBar.tolandinfo(dataitem);
						};
						if(plus.os.name == "iOS") {
							marker.setBubble(new plus.maps.Bubble("↓"));
						}
						GeometryHelper.Markers.add(dataitem, marker);
						plusMap.addOverlay(marker);
					});
				})(dataitem);
			}
		},
		MultiPolygons: [],
		MultiPolygon: {
			toPathArr: function(wkt, callback) {
				if (!wkt) return null;

				wkt = wkt.substr(0, wkt.lastIndexOf(')')).replace(/MULTIPOLYGON *?\(/gi, '');
				var arr = wkt.split(/ *\) *\) *, *\( *\(/);
				arr = arr.map(function(n) {
					return n.replace('((', '').replace('))', '').trim();
				});

				var eachPolygon = function(str, path, convertCount) {
					var p = str.split(',');
					for (var i = 0, l = p.length; i < l; i++) {
						var x = (p[i]).trim().split(' ');
						//path.push(new plus.maps.Point(Number(x[0]), Number(x[1])));
						convertCount++;
						(function(x, path) {
							plus.maps.Map.convertCoordinates(new plus.maps.Point(Number(x[0]), Number(x[1]))
							, {coordType: "gcj02"}, function(e) {
								convertCount--;
								path.push(new plus.maps.Point(e.coord.longitude, e.coord.latitude));
							});
						})(x, path);
					}
					//return path;
				};

				var res = [], convertCount = 0;
				for (var i = 0, l = arr.length; i < l; i++) {
					res[i] = [];
					eachPolygon(arr[i], res[i], convertCount);
				}
				//return res;
				var cbTimer = setInterval(function() {
					if(convertCount == 0) {
						clearInterval(cbTimer);
						callback(res);
					}
				}, 100);
			},
			build: function(dataitem) {
				var polygon = new plus.maps.Polygon(dataitem.Path);
				polygon.setStrokeColor("#fe80b9");
				polygon.setFillColor("#0066cc");
				polygon.setFillOpacity(0.2);
				polygon.setLineWidth(2);
				GeometryHelper.MultiPolygons.push(polygon);
				return polygon;
			}
		},
		UserMarker: {
			build: function(dataitem) {
				var plusPoint = new plus.maps.Point(Number(dataitem.Lng), Number(dataitem.Lat));
				userMarker = new plus.maps.Marker(plusPoint);
				dataitem.Type == "marker" ? userMarker.setIcon("../../icon/pin/pin_green@2x.png") : userMarker.setIcon("../../icon/pin/userlocation@2x.png");
				
				var info = {address: "正在获取地理位置信息..."};
				plus.maps.Map.reverseGeocode(plusPoint, {coordType: "bd09ll"}, function(event){
					var piEle = document.getElementById("postionInfo");
					if(piEle){
						piEle.innerHTML = info.address = event.address ? event.address : "无法获取当前地址信息";
					}
					userMarker.onclick = function() {
						changeBar.tolocation(info);
					};
				});
				changeBar.tolocation(info);
				
				plusMap.addOverlay(userMarker);
			},
			clear: function() {
				plusMap.removeOverlay(userMarker);
			}
		}
	};

	var query = {
		type: queryType,
		defaultFilterType: {
			YUGONGYING: [],
			ZHAOPAIGUA: [0],
			PEITAO: [501, 502, 503, 504],
			XIANGMU: [2]
		},
		errorFun: function() {
			plus.nativeUI.toast(
				'查询失败，请稍后重试...', {
					align: 'center',
					verticalAlign: 'center'
				}
			);
		},
		queryPara: {},
		query: function(type) {
			if (!userPosition) {
				plus.nativeUI.toast(
					'请先定位', {
						align: 'center',
						verticalAlign: 'center'
					}
				);
				return false;
			}
			plusMap.centerAndZoom(new plus.maps.Point(Number(userPosition.Lng), Number(userPosition.Lat)), 15);

			var queryPara = query.queryPara = {
				lat: userPosition.Lat,
				lng: userPosition.Lng,
				type: query.type[type],
				filterType: query.defaultFilterType[type],
				userId: mui._appUserInfo.userId
			};
			
			GeometryHelper.Markers.clearAll();
			query.doQuery(queryPara);
			
			plus.webview.getWebviewById("view/land/land_map_menu.html")
			.evalJS("initPOIType('"+type+"','"+JSON.stringify(queryPara.filterType)+"')");
		},
		querySub: function(subType, isShow) {
			var type = query.queryPara.type;
			if(isShow == "false") {
				if(GeometryHelper.Markers.Items[type] && GeometryHelper.Markers.Items[type][subType]) {
					GeometryHelper.Markers.show(type, subType);
				} else {
					query.queryPara.filterType = [subType];
					query.doQuery(query.queryPara);
				}
			} else {
				GeometryHelper.Markers.hide(type, subType);
			}
		},
		doQuery: function(para) {
			var successFun = function(data) {
				if (data.length < 1) {
					plus.nativeUI.toast(
						'当前范围内无符合条件的数据', {
							align: 'center',
							verticalAlign: 'center'
						}
					);
				} else {
					mui('.mui-icon-right-nav')[0].style.display = 'block';

					if (para.type == queryType.PEITAO) {
						for (var k in data) {
							if (!data[k]) {
								continue;
							}
							for (var n = 0; n < data[k].length; n++) {
								var item = data[k][n];
								//创建对应的marker
								if (item.Lng && item.Lat) {
									item._type = para.type;
									item._POIType = peitaoSubtype[k];
									item.Icon = '_www/icon/pin/' + getIconName(item);
									//plusMap.addOverlay(GeometryHelper.Marker.build(item));
									GeometryHelper.Marker.build(item);
								}
							}
						}
					} else {
						for (var n = 0; n < data.length; n++) {
							var item = data[n];
							//创建对应的marker
							if (item.Lng && item.Lat) {
								item._type = para.type;
								switch (para.type){
									case query.type.ZHAOPAIGUA:
										item._POIType = item.type;
										break;
									case query.type.XIANGMU:
										item._POIType = item.SaleTypeId;
										break;
								}
								item.Icon = '_www/icon/pin/' + getIconName(item);
								//plusMap.addOverlay(GeometryHelper.Marker.build(item));
								GeometryHelper.Marker.build(item);
							}
							//创建多边形*********
							if (item.GeomMulti) {
								GeometryHelper.MultiPolygon.toPathArr(item.GeomMulti, function(arr) {
									for (var m = 0; m < arr.length; m++) {
										item.Path = arr[m];
										plusMap.addOverlay(GeometryHelper.MultiPolygon.build(item));
									}
								});
							}
						}
					}
				}
			};
			mui.post({
				url: 'api/around',
				data: para,
				error: query.errorFun,
				success: successFun
			});
			return false;
		} //doQuery end
	};

	var mapDefaultClick = function() {
		changeBar.toicon();
	};

	function amapInit() {
		plusMap = new plus.maps.Map('map-container', {
			center: new plus.maps.Point(104.06667, 30.66667),
			zoom: 14,
			zoomControls: true
		});
		plusMap.onclick = mapDefaultClick;
	};

	function getIconName(dataitem) {
		var iconName = null;

		switch (dataitem._type) {
			case query.type.YUGONGYING: //预供应
				{
					var prefix = null;
					switch (dataitem.LandUseTypeId) {
						case '1': //纯住宅
							prefix = 'pin_r';
							break;
						case '2': //住宅兼容商业
							prefix = 'pin_rc';
							break;
						case '3': //商业兼容住宅
							prefix = 'pin_cr';
							break;
						case '4': //商业
							prefix = 'pin_c';
							break;
						case '5': //工业
							prefix = 'pin_i';
							break;
						case '6': //其它
							prefix = 'pin_e';
							break;
						default: //待定
							prefix = 'pin_t';
							break;
					}

					var color = null;
					if (!dataitem.PreSaleDate) {
						color = '_gray';
					} else {
						var now = new Date();
						var date = new Date(dataitem.PreSaleDate);
						var day = Math.abs(date - now) / 86400000;
						if (day <= 90) {
							color = '_red';
						} else if (day > 90 && day <= 180) {
							color = '_blue';
						} else {
							color = '_darkblue';
						}
					}

					iconName = prefix + color + '@2x.png';
				}
				break;
			case query.type.ZHAOPAIGUA: //招拍挂
				{
					var prefix = null;
					switch (dataitem.LandUseTypeId) {
						case '1': //纯住宅
							prefix = 'pin_r';
							break;
						case '2': //住宅兼容商业
							prefix = 'pin_rc';
							break;
						case '3': //商业兼容住宅
							prefix = 'pin_cr';
							break;
						case '4': //商业
							prefix = 'pin_c';
							break;
						case '5': //工业
							prefix = 'pin_i';
							break;
						case '6': //其它
							prefix = 'pin_e';
							break;
						default: //待定
							prefix = 'pin_t';
							break;
					}

					var color = null;
					switch (dataitem.type) {
						case '0':
							color = '_yellow';
							break;
						case '1':
							color = '_orange';
							break;
						case '2':
							color = '_red';
							break;
						default:
							color = '_gray';
							break;
					}

					iconName = prefix + color + '@2x.png';
				}
				break;
			case query.type.PEITAO: //配套
				{
					switch (dataitem._POIType) {
						case peitaoSubtype["hospResult"]:
							iconName = 'pin_ss' + '_hospital' + '@2x.png';
							break;
						case peitaoSubtype["schoolResult"]:
							iconName = 'pin_ss' + '_school' + '@2x.png';
							break;
						case peitaoSubtype["com"]:
							iconName = 'pin_c' + '_blue' + '@2x.png';
							break;
						case peitaoSubtype["bankResult"]:
							iconName = 'pin_ss' + '_bank' + '@2x.png';
							break;
						case peitaoSubtype["trackStation"]:
							iconName = 'pin_ss' + '_subway' + '@2x.png';
							break;
						default:
							iconName = 'pin_nocharacter_blue@2x.png';
							break;
					}
				}
				break;
			case query.type.XIANGMU: //项目
				{
					switch (dataitem.SaleTypeId) {
						case '1': //未售
							iconName = 'pin_r' + '_red' + '@2x.png';
							break;
						case '2': //在售
							iconName = 'pin_r' + '_yellow' + '@2x.png';
							break;
						case '5': //售罄
							iconName = 'pin_r' + '_gray' + '@2x.png';
							break;
						default:
							iconName = 'pin_r' + '_blue' + '@2x.png';
							break;
					}
				}
				break;
		}

		return iconName;
	};

	var mapApi = {
		init: function() {
			changeBar.toicon();
			mui.plusReady(function() {
				amapInit();
				mui('header').on('tap', '.mui-icon-right-nav', function() {
					var href = this.getAttribute('data-href');
					mui.openWindow({
						id: 'view/land/' + href,
						url: href,
						waiting: {
							autoShow: false
						},
						extras: {
							listData: listData
						}
					});
				});
			});
		},
		change: {
			toicon: changeBar.toicon,
			tolocation: changeBar.tolocation,
			tolandinfo: changeBar.tolandinfo
		},
		query: query.query,
		querySub: query.querySub,
		changeMapType: mapType.change,
		mapClickMarker: function(cb) {
			userMarker && GeometryHelper.UserMarker.clear();
			plusMap.onclick = function(point) {
				userPosition = {
					Lng: point.longitude,
					Lat: point.latitude,
					Type: "marker"
				};
				GeometryHelper.UserMarker.build(userPosition);
				plusMap.onclick = mapDefaultClick;
				plus.webview.getWebviewById("view/land/land_map_component_marker.html").evalJS(cb + "()");
			}
		},
		userLocation: function() {
			plus.nativeUI.showWaiting();
			userMarker && GeometryHelper.UserMarker.clear();
			GeometryHelper.Markers.clearAll();
			plus.geolocation.getCurrentPosition(function(p) {
				plus.nativeUI.closeWaiting();
				/*
				plus.maps.Map.convertCoordinates(new plus.maps.Point(p.coords.longitude, p.coords.latitude)
				, {coordType: "bd09ll"}, function(e) {
					console.log(JSON.stringify(e))
					userPosition = {
						Lng: e.coord.longitude,
						Lat: e.coord.latitude,
						Type: "location"
					};
					GeometryHelper.UserMarker.build(userPosition);
					plusMap.centerAndZoom(new plus.maps.Point(Number(userPosition.Lng), Number(userPosition.Lat)), 15);
				});
				*/
				userPosition = {
					Lng: p.coords.longitude,
					Lat: p.coords.latitude,
					Type: "location"
				};
				GeometryHelper.UserMarker.build(userPosition);
				plusMap.centerAndZoom(new plus.maps.Point(userPosition.Lng, userPosition.Lat), 16);
			}, function(e) {
				plus.nativeUI.closeWaiting();
				plus.nativeUI.alert("无法获取当前位置信息");
			}, {geocode: false, provider: "baidu"});
		},
		landMarker: function(latlng) {
			var point = JSON.parse(latlng);
			userMarker && GeometryHelper.UserMarker.clear();
			GeometryHelper.Markers.clearAll();
			plus.maps.Map.convertCoordinates(new plus.maps.Point(Number(point.Lng), Number(point.Lat))
			, {coordType: "gcj02"}, function(e) {
				userPosition = {
					Lng: e.coord.longitude,
					Lat: e.coord.latitude,
					Type: "marker"
				};
				GeometryHelper.UserMarker.build(userPosition);
				plusMap.centerAndZoom(new plus.maps.Point(userPosition.Lng, userPosition.Lat), 15);
			});
		}
	};

	window.mapApi = mapApi;

})(this, mui, template);