//---JS基础扩展---(Object.prototype不能扩展，会导致mui报错)
String.IsNullOrEmpty = function(str) {
	if (typeof(str) == "undefined") {
		return true
	}
	return (str == null || str == "")
};
/**
 * 日期格式化
 */
Date.prototype.format = function(fmt) {
	var o = {
		"M+": this.getMonth() + 1, //月份 
		"d+": this.getDate(), //日 
		"h+": this.getHours() % 12 == 0 ? 12 : this.getHours() % 12, //小时
		"H+": this.getHours(), //小时
		"m+": this.getMinutes(), //分 
		"s+": this.getSeconds(), //秒 
		"q+": Math.floor((this.getMonth() + 3) / 3), //季度 
		"S": this.getMilliseconds() //毫秒 
	};
	if (/(y+)/.test(fmt)) {
		fmt = fmt.replace(RegExp.$1, (this.getFullYear() + "").substr(4 - RegExp.$1.length));
	}
	for (var k in o) {
		if (new RegExp("(" + k + ")").test(fmt)) {
			fmt = fmt.replace(RegExp.$1, (RegExp.$1.length == 1) ? (o[k]) : (("00" + o[k]).substr(("" + o[k]).length)));
		}
	}
	return fmt;
};
/**
 * 根据模版输出字符串
 * 调用方式StringFormat(template模版, data)
 */
String.StringFormat = function(expression) {
	var pattern = /{[^\s]([^}]*)}/gi;
	var matchs;
	var expStr;

	expStr = expression;
	matchs = expStr.match(pattern);
	if (matchs == null) {
		return expression;
	};
	if (matchs.length > 0) {
		for (var i = 0; i < matchs.length; i++) {
			var expField, expFormat;
			var value;
			var match;

			match = matchs[i];
			if (match == null || match == "") {
				continue;
			};
			expField = match.substring(1, match.length - 1);
			if (expField.indexOf('.') > 0) {
				var expFieldArr;

				expFieldArr = expField.split('.');
				if (!isNaN(expFieldArr[0])) {
					var index = 0;

					index = parseInt(expFieldArr[0]) + 1;
					expFieldArr[0] = "arguments[" + index + "]";
					expField = expFieldArr.join('.');
				};
				try {
					value = eval(expField);
				} catch (e) {
					continue;
				}
			} else if (!isNaN(parseInt(expField))) {
				try {
					value = arguments[parseInt(expField) + 1];
				} catch (e) {
					continue;
				}
			} else {
				try {
					value = eval(expField);
				} catch (e) {
					continue;
				}
			}
			if (value == null) {
				value = '';
			};
			expStr = expStr.replace(match, value);
		}
	};
	return expStr;
};
/**
 * 从对象数组中根据属性名的值检索对象
 * name：PropertyName 属性名(可为空)
 * value：PropertyValue 属性值
 */
Array.prototype.find = function(name, value) {
	for (var i = 0; i < this.length; i++) {
		if (String.IsNullOrEmpty(name)) {
			if (this[i] == value) {
				return this[i]
			}
		}
		if (this[i][name] == value) {
			return this[i]
		}
	}
	return null
};

/**
 * dom元素模拟ontap事件
 */
HTMLElement.prototype.ontap = null;
document.ontouchstart = function(e) {
	var findOnTapEle = function(ele) {
		var fun = ele.getAttribute("ontap") || ele.ontap;
		if(!fun) {
			if(ele.parentNode instanceof HTMLElement) {
				return findOnTapEle(ele.parentNode);
			} else {
				return {};
			} 
		} else {
			return {
				ele: ele
				,fun: fun
			};
		}
	};
	var targetEle = e.target;
	var tapObj = findOnTapEle(targetEle), fun = tapObj.fun, targetEle = tapObj.ele;
	var startTime = new Date(), endTime, moved = false;
	if(!!fun) {
		document.ontouchmove = function(e) {
			moved = true;
		};
		document.ontouchend = function(e) {
			endTime = new Date();
			if(endTime - startTime < 300 && !moved) {
				if(!targetEle.getAttribute("id")) {
					var RID = Math.random().toString().replace(".", "");	//后续待改进 增加不重复随机数
					targetEle.setAttribute("id", "R"+RID);
				}
				if(typeof fun == "function") {
					fun();
				} else {
					eval("(function(){"+fun+"}).call(mui('#"+targetEle.getAttribute("id")+"')[0])");
				}
			}
		}
	}
};
//---JS原生扩展end---

//mui基础扩展
(function($){
	//override为true时，覆盖
	$._extend = function(des, src, override) {
		for (var i in src) {
			if (override || !(i in des)) {
				des[i] = src[i];
			}
		}
		return des;
	};
	
	//android下打开慢 快速点击会弹多次 折中处理
	var muiOpenWindow = $.openWindow, openWindowing = false;
	$.openWindow = function(url, id, options) {
		if(openWindowing) {
			return;
		}
		var webview = muiOpenWindow(url, id, options);
		openWindowing = true;
		
		setTimeout(function() {
			openWindowing = false;
		}, 300);
		
		return webview;
	};
	
	//又一坑
	$.closeOpened = function(webview) {
		var opened = webview.opened();
		if (opened) {
			for (var i = 0, len = opened.length; i < len; i++) {
				var openedWebview = opened[i];
				var open_open = openedWebview.opened();
				if (open_open && open_open.length > 0) {
					$.closeOpened(openedWebview);
				}
				//如果直接孩子节点，就不用关闭了，因为父关闭的时候，会自动关闭子；
				if (openedWebview.parent() !== webview) {
					openedWebview.close('none');
				}
			}
		}
	};
	
	//mui的事件on二次封装 (注:on为事件的批量绑定,单个元素用addEventListener)
	/*
	var muiFnOn = $.fn.on;
	$.fn.on = function() {
		if(arguments.length > 2) {
			//muiFnOn.apply(this, arguments);
			muiFnOn.call(this, arguments[0], arguments[1], arguments[2]);
		} else {
			var muiObj = this, _event = arguments[0], _callback = arguments[1];
			var _eventlistener = setInterval(function() {
				if($(muiObj.selector).length > 0) {
					muiFnOn.call($(muiObj[0].parentNode), _event, muiObj.selector, _callback);
					clearInterval(_eventlistener);
				}
			}, 100);
		}
	};
	*/
})(mui);

//当前app基础配置
(function($){
	$.gotoLogin = function() {
		plus.webview.open("_www/login.html", "Login", "", "zoom-fade-out", 350, function(){
			var wva = plus.webview.all();
			for(var w in wva) {
				if(wva[w].id != plus.runtime.appid && wva[w].id != "Login"){
					plus.webview.close(wva[w], "none");
				}
			}
		});
	};
	var userInfo = JSON.parse(localStorage.getItem("$userInfo"));
	if(!userInfo) {	
		document.addEventListener("plusready", function(){
			//主页面的用户信息处理放在main里面处理
			if(plus.webview.currentWebview().id == plus.runtime.appid) {
				return;
			}
			var logWebView = plus.webview.getWebviewById("Login");
			if(logWebView==null) {
				$.gotoLogin();
			}
		});
	}
	$._appUserInfo = userInfo || {};
	
	//去认证
	$.gotoAuthenticate = function() {
		plus.nativeUI.confirm("您还不是实名认证用户，无法继续该操作", function(e){
			if(e.index == 1) {
				$.openWindow({
					id: "user_auth_verify.html",
					url: "_www/view/personal/user_auth_verify.html",
					styles: {
						popGesture: 'close'
					},
					waiting: {
						autoShow: false
					}
				});
			}
		}, "提示", ["以后认证", "实名认证"]);
	};
})(mui);

//mui中的ajax的post,get方法的重载
(function($){
	var netError = $.netError = function() {
		plus.nativeUI.toast("网络异常", 
			{duration:'long', align:'center', verticalAlign:'center'}
		);
	};
	var ajaxCount = 0, closeSWTimer;
	var ajaxDefaultOptions = $.ajaxDefaultOptions = {
		httpBase : "http://app.dcq.cn:13480/" ,
		timeout : 8000 ,
		contentType : "application/json" ,
		error : function(){
			if(window.plus) {
				netError();
			} else {
				document.addEventListener("plusready", function(){
					netError();
				});
			}
		}
	};
	$.ajaxSettings.beforeSend = function() {
		ajaxCount++;
		clearInterval(closeSWTimer);
		if(window.plus) {
			setTimeout(function(){
				plus.nativeUI.showWaiting();
			}, 0);
		} else {
			document.addEventListener("plusready", function(){
				plus.nativeUI.showWaiting();
			});
		}
		closeSWTimer = setInterval(function(){
			plus.nativeUI.closeWaiting();
			clearInterval(closeSWTimer);
		}, ajaxDefaultOptions["timeout"] + 100);
	};
	$.ajaxSettings.complete = function() {
		ajaxCount>0 && ajaxCount--;
		if(ajaxCount > 0) {
			return;
		}
		if(window.plus) {
			setTimeout(function(){
				plus.nativeUI.closeWaiting();
			}, 250);
		} else {
			document.addEventListener("plusready", function(){
				plus.nativeUI.closeWaiting();
			});
		}
	};
	
	$.get = function(options) {
		$._extend(options, ajaxDefaultOptions);
		if(!/^http:\/\//.test(options.url)) {
			options.url = ajaxDefaultOptions.httpBase + options.url;
		}
		options.type = "GET";
		return $.ajax(options);
	};
	
	$.post = function(options) {
		$._extend(options, ajaxDefaultOptions);
		if(!/^http:\/\//.test(options.url)) {
			options.url = ajaxDefaultOptions.httpBase + options.url;
		}
		options.type = "POST";
		if($.isObject(options.data)) {
			options.data = JSON.stringify(options.data);
		}
		return $.ajax(options);
	};
})(mui);

//元素的绑定值，设置值，获取值，清除值，验证表单的自定义方法
(function($){
	var _bindData = function(ele, dataList) {
		var eleType = ele.tagName.toLowerCase();
		var valueField = ele.getAttribute("valuefield"), textField = ele.getAttribute("textfield");
		var templateId = ele.getAttribute("template");
		if(templateId) {
			eleType = "template";
		}
		switch (eleType){
			case "select":
				for(var i=0; i<dataList.length; i++) {
					var option = document.createElement("option");
					option.value = dataList[i][valueField];
					option.innerHTML = dataList[i][textField];
					ele.appendChild(option);
				}
				break;
			case "template":
				var _template = $(templateId)[0].innerHTML.replace("<!--","").replace("-->","").replace(/(^\s*)|(\s*$)/g, "");
				for(var i=0; i<dataList.length; i++) {
					$(ele).append(String.StringFormat(_template, dataList[i]));
				}
				break;
		}
	};
	var _setValue = function(ele, data) {
		if(!data) {
			var _defaultV = ele.getAttribute("defval");
			data = _defaultV ? _defaultV : "";
		}
		var eleType = ele.tagName.toLowerCase();
		var templateId = ele.getAttribute("template");
		if(templateId) {
			eleType = "template";
		}
		switch (eleType){
			case "input":
				var _type = ele.getAttribute("type");
				switch (_type){
					case "text":
						ele.value = data;
						break;
					case "checkbox":
						ele.checked = data;
						break;
				}
				break;
			case "textarea":
				ele.value = data;
				break;
			case "img":
				if(data == "") {
					ele.removeAttribute("src");
				} else {
					ele.src = data;
				}
				break;
			case "select":
				for(var i=0; i<ele.options.length; i++) {
					if(ele.options[i].value == data) {
						ele.options[i].selected = true;
						break;
					}
				}
				break;
			case "label":
				ele.innerHTML = data;
				break;
			case "template":
				if(data instanceof Array) {
					_bindData(ele, data);
				} else {
					var _template = $(templateId)[0].innerHTML.replace("<!--","").replace("-->","").replace(/(^\s*)|(\s*$)/g, "");
					ele.innerHTML = String.StringFormat(_template, data);
				}
				break;
		}
	};
	var _getValue = function(ele, data, datafld) {
		var eleType = ele.tagName.toLowerCase();
		switch (eleType){
			case "input":
				var _type = ele.getAttribute("type");
				switch (_type){
					case "text":
						data[datafld] = ele.value.trim();
						break;
					case "checkbox":
						data[datafld] = ele.checked;
						break;
				}
				break;
			case "textarea":
				data[datafld] = ele.value.trim();
				break;
			case "label":
				data[datafld] = ele.innerHTML;
				break;
			case "img":
				data[datafld] = ele.src;
				break;
			case "select":
				for(var i=0; i<ele.options.length; i++) {
					if(ele.options[i].selected == true) {
						data[datafld] = ele.options[i].value;
						break;
					}
				}
				break;
		}
	};
	var _clearValue = function(ele) {
		var eleType = ele.tagName.toLowerCase();
		var templateId = ele.getAttribute("template");
		if(templateId) {
			eleType = "template";
		}
		switch (eleType){
			case "input":
				var _type = ele.getAttribute("type");
				switch (_type){
					case "text":
						ele.value = "";
						break;
					case "checkbox":
						ele.checked = false;
						break;
				}
				break;
			case "textarea":
				ele.value = "";
				break;
			case "label":
				ele.innerHTML = "";
				break;
			case "img":
				ele.src = "";
				break;
			case "template":
				ele.innerHTML = "";
				break;
		}
	};
	var _validate = function(ele) {
		var _content = "";
		var eleType = ele.tagName.toLowerCase();
		switch (eleType){
			case "input":
				_content = ele.value;
				break;
			case "textarea":
				_content = ele.value;
				break;
			case "img":
				_content = ele.src;
				break;
		}
		return !String.IsNullOrEmpty(_content);
	};
	
	/**
	 * 给元素绑定多个子元素值
	 * valuefield是binddata中list里data的值字段名
 	 * textfield是binddata中list里data的文本字段名
	 */
	$.fn.bindData = function(data) {
		this.each(function(i, ele) {
			var eleData = data[ele.getAttribute("datafld")];
			_bindData(ele, eleData);
		});
	};
	
	/**
	 * 设置元素的值
	 * datafld为data的key
	 */
	$.fn.setValue = function(data) {
		this.each(function(i, ele) {
			var eleData = data[ele.getAttribute("datafld")];
			_setValue(ele, eleData);
		});
	};
	
	/**
	 * 获取元素的datafld值
	 * 返回data[datafld]键值对
	 */
	$.fn.getValue = function() {
		var data = {};
		this.each(function(i, ele) {
			var eleDataFld = ele.getAttribute("datafld");
			_getValue(ele, data, eleDataFld);
		});
		return data;
	};
	
	/**
	 * 清除元素绑定的值
	 */
	$.fn.clearValue = function() {
		this.each(function(i, ele) {
			_clearValue(ele);
		});
	};
	
	/**
	 * 表单验证 (待扩展) 现在只是简单的非空验证
	 */
	$.fn.validate = function() {
		var r = true;
		this.each(function(i, ele) {
			r = _validate(ele);
			return r;
		});
		return r;
	};
})(mui);

//mui操作元素的方法扩展
(function($){
	//creatElementByString
	var cEBS = function(htmlStr) {
		var nodeContainer = document.createElement("div");
		nodeContainer.innerHTML = htmlStr;
		var elementNode = nodeContainer.childNodes[0];
		nodeContainer = null;
		return elementNode;
	};
	
	$.fn.before = function(newEle) {
		var ele = this[0];
		newEle = newEle instanceof HTMLDocument ? newEle : cEBS(newEle);
		ele.insertBefore(newEle); 
	};
	
	$.fn.after = function(newEle) {
		var ele = this[0];
		newEle = newEle instanceof HTMLDocument ? newEle : cEBS(newEle);
		var parentEle = ele.parentNode; 
		if(parentEle.lastChild == ele) { 
			parentEle.appendChild(newEle); 
		} else {
			parentEle.insertBefore(newEle, ele.nextSibling); 
		}
	};
	
	$.fn.append = function(newEle) {
		var ele = this[0];
		newEle = newEle instanceof HTMLDocument ? newEle : cEBS(newEle);
		ele.appendChild(newEle);
	};
	
	$.fn.remove = function() {
		var ele = this[0];
		if(!ele) {
			return;
		}
		var parentEle = ele.parentNode;
		parentEle.removeChild(ele);
	};
})(mui);