/**
 *
 **/
(function($, owner) {
	/**
	 * 用户登录
	 **/
	owner.login = function(loginInfo, callback) {
		callback = callback || $.noop;
		var loginParam = loginInfo || {};
		loginParam.email = loginInfo.account || '';
		loginParam.password = loginInfo.password || '';
		if (loginParam.account.length < 1) {
			document.getElementById("account").focus();
			return callback('请填写账号');
		}
		if (loginParam.password.length < 6) {
			document.getElementById("password").focus();
			return callback('请输入6~16位有效密码');
		}
		if(mui.os.ios){
			loginParam.clientType="0";
		}else{
			loginParam.clientType="1";
		}
		var clientToken=localStorage.getItem("$clientToken")||"";
		if(clientToken!=""){
			loginParam.token=clientToken;
		}
	    mui.post({
				url:'api/user/login',
				data: "json",
                contentType: "application/json; charset=utf-8",
                data: JSON.stringify(loginParam),
				success:function(data){					
					//console.log(JSON.stringify(data));					
					var status=data.status;
					if(status&&status=="1"){												
						return owner.createUserInfo(data, callback);	
					}else{
						return callback(data.msg);	
					}
				},
				error:function(xhr,type,errorThrown){
					 return callback("网络错误");
				}
			});
	};

    /**
     *第三方登录 
     */
    owner.oauthLogin=function (loginInfo,callback) {
     	callback=callback||$.noop;
     	loginInfo=loginInfo||{};
     	loginInfo.oauthId=loginInfo.oauthId||{};
     	loginInfo.nickName=loginInfo.nickName||{};
     	loginInfo.oauthType=loginInfo.oauthType||{};  
     	if(mui.os.ios){
			loginInfo.clientType="0";
		}else{
			loginInfo.clientType="1";
		}
		var clientToken=localStorage.getItem("$clientToken")||"";
		if(clientToken!=""){
			loginInfo.token=clientToken;
		}
	    mui.post({
			url:'api/user/oauth',
			data: "json",
	        contentType: "application/json; charset=utf-8",
	        data: JSON.stringify(loginInfo),
			success:function(data){					
				//console.log(JSON.stringify(data));					
				var status=data.status;
				if(status&&status=="1"){												
					return owner.createUserInfo(data,callback);	
				}else{
					return callback(data.msg);	
				}
			},
			error:function(xhr,type,errorThrown){					
 				return callback("网络错误");
			}
	     });
     };

    /**
     * 创建登陆用户信息信息
     * @param {Object} data
     * @param {Object} callback
     */
	owner.createUserInfo = function(data, callback) {
		var userInfo = owner.getUserInfo()||{};
		//console.log(JSON.stringify(data));
		userInfo.userId=data.user.id;
		userInfo.userNickName=data.user.nickName;
		userInfo.user=data.user;
		owner.setUserInfo(userInfo);
		//console.log(JSON.stringify(owner.getUserInfo()));
		plus.nativeUI.toast(data.msg);
		return callback();
	};

	/**
	 * 新用户注册
	 **/
	owner.reg = function(regInfo, callback) {
		callback = callback || $.noop;
		regInfo = regInfo || {};
		regInfo.mobile = regInfo.mobile || '';
		regInfo.password = regInfo.password || '';
		regInfo.nickName = regInfo.nickName || '';
		regInfo.verifyCode = regInfo.verifyCode || '';
		var mobileReg = !!regInfo.mobile.match(/^(0|86|17951)?(13[0-9]|15[012356789]|17[678]|18[0-9]|14[57])[0-9]{8}$/);
		//如果手机号码不能通过验证
		if(mobileReg == false){
			document.getElementById("mobile").focus();
			return callback('请输入正确的手机号码');
		}
		var pswReg=!!regInfo.password.match(/^[a-zA-Z|0-9]\w{5,15}$/);
		if(pswReg == false){
			document.getElementById("password").focus();
			return callback('请输入6~16位由数字、字符及下划线组成的密码，且首字母不能为下划线');
		}
		/*if (regInfo.password.length < 6||regInfo.password.length>16) {
			return callback('请输入6~16位由数字、字符及下划线组成的密码，且首字母不能为下划线');
		}*/
		if (regInfo.nickName.length==0) {
			document.getElementById("nickName").focus();
			return callback('请输入昵称');
		}
		if(regInfo.nickName.length>12){
			document.getElementById("nickName").focus();
			return callback('昵称过长');
		}
		if(regInfo.verifyCode.length=0){
			document.getElementById("verCode").focus();
			return callback('请输入短信中获取的验证码');
		}
		if(regInfo.verifyCode.length!=6){
			document.getElementById("verCode").focus();
			return callback('验证码不正确');
		}
		if(mui.os.ios){
			regInfo.clientType="0";
		}else{
			regInfo.clientType="1";
		}
		var clientToken=localStorage.getItem("$clientToken")||"";
		if(clientToken!=""){
			regInfo.token=clientToken;
		}
		mui.post({
				url:'api/user/reg',
				data: "json",
                contentType: "application/json; charset=utf-8",
                data: JSON.stringify(regInfo),
				success:function(data){									
					var status=data.status;
					if(status&&status=="1"){		
						data.user=data.data;
						return owner.createUserInfo(data, callback);	
					}else{
						return callback(data.msg);	
					}
				},
				error:function(xhr,type,errorThrown){					
				   return callback("网络错误");
				}
			});
	};

	/**
	 * 获取验证码
	 */
	owner.getVerCode=function (mobileInfo,callback) {
		callback = callback || $.noop;
		mobileInfo = mobileInfo || {};
		mobileInfo.mobile = mobileInfo.mobile || '';
		var mobileReg = !!mobileInfo.mobile.match(/^(0|86|17951)?(13[0-9]|15[012356789]|17[678]|18[0-9]|14[57])[0-9]{8}$/);
		//如果手机号码不能通过验证
		if(mobileReg == false){
			document.getElementById("mobile").focus();
			return callback('请输入正确的手机号码');
		}		
		//return callback();
		mui.post({
				url:'api/user/reg/sendsms',
				data: "json",
                contentType: "application/json; charset=utf-8",
                data: JSON.stringify(mobileInfo),
				success:function(data){									
					var status=data.status;
					if(status&&status=="1"){		
						plus.nativeUI.toast("已发送验证短信，请稍等");
						return callback();
					}else{
						return callback(data.msg);	
					}
				},
				error:function(xhr,type,errorThrown){					
				   return callback("网络错误");
				}
			});
	}; 

	/**
	 * 获取当前登陆信息
	 **/
	owner.getUserInfo = function() {
		var userInfo = localStorage.getItem('$userInfo') || "{}";
		return JSON.parse(userInfo);
	};

	/**
	 * 设置当前登陆信息
	 **/
	owner.setUserInfo = function(userInfo) {
		userInfo = userInfo || {};
		//console.log(JSON.stringify(userInfo));
		localStorage.setItem('$userInfo', JSON.stringify(userInfo));
	};

}(mui, window.app = {}));